//
// gaussian.h
//
// Produce numbers with gaussian distribution
//
// Copyright (C) J. Belson	2000.08.13
//

#ifndef _GAUSSIAN_H_
#define _GAUSSIAN_H_

#include <cstdlib>
#include <cmath>

class gaussian {

private:
	long int acc;

	long int ms_rand(void) {
		acc = (16807*acc)%2147483647;
		return acc;
	}

	float ran1(void) {
		return (1.0*ms_rand()/(RAND_MAX+1.0));
	}

public:
	gaussian(long int seed = 123345) {
		acc = seed;
	}

	float gasdev(void)
	{
		float x1, x2, w, y1, y2;
	 
		do {
			x1 = 2.0 * ran1() - 1.0;
			x2 = 2.0 * ran1() - 1.0;
			w = x1 * x1 + x2 * x2;
		} while ( w >= 1.0 );
	
		w = sqrt((-2.0 * log(w)) / w);
		y1 = x1 * w;
		y2 = x2 * w;
	
		return y1;
	}



};


#endif	// _GAUSSIAN_H_


