

#include "hf_hetero.h"

#include <math.h>

#define MAX_OCTAVES	8

	static double   exponent_array[MAX_OCTAVES];



hf_hetero::hf_hetero()
{
	/* precompute and store spectral weights */
		/* compute weight for each frequency */
		for (int i=0; i<MAX_OCTAVES; i++)
			exponent_array[i] = pow( lacunarity, -i*H );

	offset = 1;
	lacunarity = 2;
	H = 1;
	offset = 1;
	gain = 2;

	noise = new perlin2();

srandom(2345);
srand(234534);
}


hf_hetero::~hf_hetero()
{
	delete noise;
}










// Get height at arbitrary heightfield point...
float hf_hetero::get_height(float x, float y)
{
x /= 30.0;
y /= 30.0;

	struct Vector { float x, y, z; } point;

	point.x = x;
	point.y = 1.0;
	point.z = y;

	float vec[3];

	/* get first octave */
	vec[0] = point.x;
	vec[1] = point.y;
	vec[2] = point.z;
	signal = noise->noise3( vec /*point*/ );
	/* get absolute value of signal (this creates the ridges) */
	if ( signal < 0.0 ) signal = -signal;
	/* invert and translate (note that "offset" should be ~= 1.0) */
	signal = offset - signal;
	/* square the signal, to increase "sharpness" of ridges */
	signal *= signal;
	/* assign initial values */
	result = signal;
	weight = 1.0;

	for( int i=1; weight>0.001 && i<octaves; i++ ) {
		point.x *= lacunarity;
		point.y *= lacunarity;
		point.z *= lacunarity;

		/* weight successive contributions by previous signal */
		weight = signal * gain;
		if ( weight > 1.0 ) weight = 1.0;
		if ( weight < 0.0 ) weight = 0.0;
	vec[0] = point.x;
	vec[1] = point.y;
	vec[2] = point.z;
		signal = noise->noise3( vec /*point*/ );
		if ( signal < 0.0 ) signal = -signal;
		signal = offset - signal;
		signal *= signal;
		/* weight the contribution */
		signal *= weight;
		result += signal * exponent_array[i];
	}
result *= 20;
	return( result );

} /* RidgedMultifractal() */



// Override basic seed_rand
void hf_hetero::seed_rand(unsigned long int s)
{

}
