//
// hf_multifactal.h
//
// Create multifractal heightfield using Perlin noise
// From 'Procedural Texturing and Modelling'
//
// My bits Copyright (C) J. Belson	2001.06.01
//
// $Author: jon $ : $Date: 2003/07/26 17:01:33 $
//


#ifndef _HF_MULTIFRACTAL_H_
#define _HF_MULTIFRACTAL_H_

#include "hf.h"
//#include "perlin2.h"

class my_noise;
class settings;


/**
 * Create multifractal heightfield
 */
class hf_multifractal : public hf {

private:
	float _lacunarity;
	double _value;
	double _offset;
	float _scaling;

	double* _exponent_array;

	float _iterations;

	my_noise* _noise;

public:
	hf_multifractal(void);
	~hf_multifractal();

	// Get height at arbitrary heightfield point...
	virtual float get_height(float x, float y);

	// Set number of iterations of algorithm
	void set_iterations(int val) { _iterations = val; };
};


#endif	// _HF_MULTIFRACTAL_H_

