//
// hf_perlin2.h
//
// From 'Procedural Texturing and Modelling'
//
// My bits Copyright (C) J. Belson 2001.06.17
//


#ifndef _HF_PERLIN2_H_
#define _HF_PERLIN2_H_


#include "hf.h"

#define MY_NOISE

class my_noise;
class settings;

/**
 * Create a heightfield using perlin2 algorithm.
 */
class hf_perlin2 : public hf {

private:
	double* exponent_array;

	float lacunarity, octaves, scaling;

	my_noise* noise;

	//settings* my_settings;

public:
	// Create an instance of a perlin2 heightfield
	hf_perlin2(void);
	~hf_perlin2();

	// Get height at arbitrary heightfield point...
	virtual float get_height(float x, float y);

	// Set number of iterations of algorithm to use
	void set_iterations(int val);
};


#endif	// _HF_PERLIN2_H_

