//
// Perlin noise generator
//
// Copyright (C) J. Belson 2003.02.08
//
// $Id: hf_ridged_perlin.h,v 1.5 2003/10/11 18:11:00 jon Exp $
//

#ifndef _HF_RIDGED_PERLIN_H_
#define _HF_RIDGED_PERLIN_H_

#include "hf.h"


class my_noise;

/**
 * Class to generate ridged perlin terrain.
 */
class hf_ridged_perlin : public hf
{
private:
	my_noise* noise;

	double* exponent_array;
	float frequency, signal, weight, H, lacunarity, offs;
	float octaves, gain, scaling;

	float ridged_perlin(double x, double y);
	float hetero(double x, double y);

public:
	hf_ridged_perlin();
	~hf_ridged_perlin();

	// Get height at arbitrary heightfield point...
	virtual float get_height(float x, float y);
};

#endif	// _HF_RIDGED_PERLIN_H_
