//
// hf_skydome.h
//
// Create skydome heightfield
//
// Copyright (C) J. Belson	2002.08.16
//

#ifndef _HF_SKYDOME_H_
#define _HF_SKYDOME_H_

#include "hf.h"

/**
 * Represent a skydome as a heightfield
 */
class hf_skydome : public hf {

private:
	enum {
		SKYDOME_OFFSET	= 1200,
		SCALE			= 5
	};

	virtual int index(int x, int y) {
		return (y*(map_size+1) + x);
	}


public:
	hf_skydome(void);

	// Effective size of terrain
	virtual int get_width(void)	{ return SCALE*TERRAIN_WIDTH; }

	// Get height at arbitrary heightfield point...
	virtual float get_height(float x, float y);

	// Trace ray to see if it intersects terrain
	virtual bool trace_path(point3d& p, vector3d view);

};

#endif	// _HF_SKYDOME_H_
