//
// hf_synthesis.h
//
// Create heightfield using spectral synthesis
//
// Copyright (C) J. Belson	2000.02.05
//


#ifndef _HF_SYNTHESIS_H_
#define _HF_SYNTHESIS_H_

#include "hf.h"


// Please note: this class uses FFT code written
// by Takuya OOURA.  For more information see
// http://momonga.t.u-tokyo.ac.jp/~ooura/fft.html


class hf_synthesis : public hf {

private:

	void InvFFT(float* relief, float* relief_buffer, int map_size);

	void fourn(float* data, int* nn, int ndim, int isign);

	float& Real(float* v, int x, int y) {
		return v[1 + ((x * TERRAIN_WIDTH) + y) * 2];
	}
	float& Imag(float* v, int x, int y) {
		return v[2 + ((x * TERRAIN_WIDTH) + y) * 2];
	}

public:
	hf_synthesis(int size, float fd);
	~hf_synthesis();

	// Generate relief map
	virtual void generate(float std_dev, float h);
};

#endif	// _HF_SYNTHESIS_H_
