//
// Perlin noise generator
//
// Copyright (C) J. Belson 2003.07.26
//
// $Id: noise.h,v 1.2 2003/07/26 17:08:00 jon Exp $
//


#ifndef _NOISE_H_
#define _NOISE_H_

#include "point2d.h"


/**
 * Reimplementation of perlin noise generator.
 */
class my_noise {

	enum {
		TABLE_SIZE	=	256
	};

private:
	// Map point coordinates to gradients
	int perms[TABLE_SIZE];

	// Gradients for each dimension
	float gradient1[TABLE_SIZE];
	float gradient2[TABLE_SIZE][2];
	float gradient3[TABLE_SIZE][3];

	bool done_init;

	void init(void);

	float unit_rand(void);

	void normalise2(float* val);

	float interpolate(float f);

public:
	my_noise();

	float noise2(float x, float y);
	float noise2(point2d p) {
		return noise2(p.x, p.y);		
	}
};




#endif	// _NOISE_H_
