//
// perlin2.h
//
// From 'Procedural Texturing and Modelling'
//
// My bits Copyright (C) J. Belson 2001.06.11
//


#ifndef _PERLIN2_H_
#define _PERLIN2_H_

#include "point2d.h"
#include "point3d.h"


/**
 * Perlin noise generator derived from 'Procedural Texturing and Modelling'
 */
class perlin2 {


private:

	enum {
//		B = 256;
	};

	static const float	DEFAULT_FREQ_SCALE;

	static const int B = 256;

	int p[B + B + 2];

	float g1[B + B + 2];
	float g2[B + B + 2][2];
	float g3[B + B + 2][3];

	float freq_scale;

	// Called init() yet?
	bool done_init;

	void init(void);

	float DOT(float* a, float* b);
	float setup(int i, int b0, int b1, float r0, float r1);

public:
	perlin2();

	float noise2(float vec[2]);
	float noise2(float x, float y) {
		float vec[2] = { x/32.0, y/32.0 };
		return noise2(vec);
	}
	float noise2(const point2d& p2d) {
		float vec[2] = { p2d.x/32.0, p2d.y/32.0 };
		return noise2(vec);
	}

	float noise3(float vec[3]);
	float noise3(const point3d& p3d) {
		float vec[3] = { p3d.x, p3d.y, p3d.z };
		return noise3(vec);
	}

	void set_seed(int val);

	void set_freq_scale(float val);
};

#endif	// _PERLIN2_H_
