//
// main.cc
//
// Landscape main program
//
// Copyright (C) J. Belson	1998.30.11
//


#include <iostream.h>
#include <time.h>
#include <math.h>
#include <stdlib.h>

#include "view.h"
#include "app.h"
#include "point3d.h"
#include "settings.h"
#include "triangle3d.h"
#include "vector3d.h"
#include "util.h"
#include "hf_fbm.h"
#include "preferences.h"
#include "Preferences.h"

#include "terrain.h"
#include "gradient.h"
#include "interpolate.h"
#include "fcolour.h"


Preferences gPrefs("x-vnd.jon-landscape");
PreferenceSet gSettings(gPrefs, "landscape", true);


int main(void)
{
	srand((unsigned int) time(NULL));

	// Load user's preferences
	if (gPrefs.InitCheck()) {
		cerr << "Cannot initialise preferences" << endl;
		exit (1);
	}
	if (gSettings.InitCheck()) {
		cerr << "Cannot get settings" << endl;
		exit (1);
	}


	my_app *app = new my_app();
	app->Run();

	cout << "Bye!!" << endl;

	delete app;
	return 0;
}

