//  
// rng.cc
//  
// Minimum standard random number generator
//
// Copyright (c) J. Belson  2003.01.14
//  


#include "rng.h"


/**
 * Get next pseudo-random number
 * @return next number
 */
long int rng::ms_rand(void)
{
    seed = (16807*seed)%2147483647;
    return seed;
}



/**
 * Seed random number generator. This allows a
 *  particular noise pattern to be reproduced.
 */
void rng::seed(unsigned long int s)
{

}



/**
 * Generate a floating point number between 0 and 1
 */
float rng::get_rand(void)
{
    return (1.0* ms_rand()/(RAND_MAX+1.0));
}


