//
// transform.cc
//
// Various transformation functions
//
// Copyright (C) 1999.11.21
//


#include <cassert>
#include <iostream>
#include <cmath>

#include "transform.h"


#if 0
//
// Apply x, y, z rotation to array of point3d
//
void transform::rotate(point3d* p3d, int num_points, float rot_x, float rot_y, float rot_z)
{
	for (int i=0; i<num_points; i++) {
		float x, y, z;

		// x rotation
		x = p3d[i].x; 
		y = p3d[i].y; 
		z = p3d[i].z; 

		p3d[i].x = x;
		p3d[i].y = y*cos(rot_x) + z*sin(rot_x);
		p3d[i].z = -y*sin(rot_x) + z*cos(rot_x);

		// y rotation
		x = p3d[i].x; 
		y = p3d[i].y; 
		z = p3d[i].z; 

		p3d[i].x = x*cos(rot_y) + z*sin(rot_y);
		p3d[i].y = y;
		p3d[i].z = -x*sin(rot_y) + z*cos(rot_y);

	}
}

//
// Apply x, y, z rotation to array of vector3d
//
void transform::rotate(vector3d* v3d, int num_points, float rot_x, float rot_y, float rot_z)
{
	for (int i=0; i<num_points; i++) {
		float x, y, z;

		x = v3d[i].i;
		y = v3d[i].j;
		z = v3d[i].k;

		v3d[i].i = x*cos(rot_y) + z*sin(rot_y);
		v3d[i].j = y;
		v3d[i].k = -x*sin(rot_y) + z*cos(rot_y);
	}

}


//
// Apply a x, y, z translation to array of point3d
//
void transform::translate(point3d* p3d, int num_points, float off_x, float off_y, float off_z)
{
	for (int i=0; i<num_points; i++) {
		p3d[i].x += off_x;
		p3d[i].y += off_y;
		p3d[i].z += off_z;
	}

}

void transform::translate(vector3d* v3d, int num_points, float off_x, float off_y, float off_z)
{
	// Don't need to translate vectors
}



//
// Apply perspective transformation to points
//
void transform::perspective(const point3d* p3d, point2d* p2d, int num_points, int map_width)
{
	std::cout << "transform::perspective\n";
	assert(p3d);
	assert(p2d);

	for (int i=0; i<num_points; i++) {
		float x, y, z;
		float new_x, new_y;
		uint8 r, g, b;
		float s, t;

		x = p3d[i].x;
		y = p3d[i].y;
		z = p3d[i].z;

		r = p3d[i].r;
		g = p3d[i].g;
		b = p3d[i].b;

		s = p3d[i].s;
		t = p3d[i].t;

		if (z) {
			new_x = x / (z / map_width);
			new_y = y / (z / map_width);
		} else {
			new_x = x;
			new_y = y;
		}

		p2d[i].x	= (new_x);
		p2d[i].y	= (new_y);
		p2d[i].depth= z;

		p2d[i].r = r;
		p2d[i].g = g;
		p2d[i].b = b;

		p2d[i].s = s;
		p2d[i].t = t;

		//cout << "p3d "; p3d[i].print();
		//cout << "p2d "; p2d[i].print();
		//cout << endl;
	}

}


#endif






