//
// triangle2d.h
//
// An array of three point2d.
//
// Copyright (C) J. Belson	1998.12.19
//


#ifndef _TRIANGLE2D_H_
#define _TRIANGLE2D_H_

#include "point2d.h"
#include "vector3d.h"


/**
 * Represents a triange in 2d space
 */
class triangle2d {

	private:

		void debug(char *msg) { cout << msg << endl; }

	public:
		triangle2d(point2d *p1, point2d *p2, point2d *p3);
		triangle2d(void) { };

		point2d *point[3];		// Array of vertices in 2d space
		vector3d v_normal[3];	// Vector normal for each vertex

		vector3d normal;		// Normal of original 3d triangle
		bool visible;

		void get(point2d *p1, point2d *p2, point2d *p3);
		void set(point2d *p1, point2d *p2, point2d *p3);

		void dump(void);
};

#endif	// _TRIANGLE2D_H_
