//
// texture_skylight.cc
//
// Skylight texture.
//
// Copyright (C) J. Belson	2003.09.27
//
// $Id: texture_skylight.h,v 1.1 2003/10/11 18:11:00 jon Exp $
//


#ifndef _TEXTURE_SKYLIGHT_H_
#define _TEXTURE_SKYLIGHT_H_

#include "texture.h"


/**
 * Settings structure for skylight texture.
 */
struct textset_skylight : public textset_noise
{
	vector3d sun_direction;		// Direction of sun
};


/**
 * Skylight texture.
 */
class texture_skylight : public texture {
private:
	skylight*	sky;
	vector3d	sun_direction;

public:
	texture_skylight(const textset_skylight& ts);
	virtual ~texture_skylight();

	virtual fcolour colour(float s, float t, float u = 0, vector3d* view_direction = 0);
};





#endif	// _TEXTURE_SKYLIGHT_H_
