//
// Test primitives against a viewing frustrum.
//
// Copyright (c) J. Belson	2003.05.29
//
// $Author: jon $	:	$Date: 2003/05/30 17:50:44 $
//


#ifndef _FRUSTRUM_H_
#define _FRUSTRUM_H_

class point3d;


/**
 * Class representing a viewing frustrum.  We can make things
 *  very simple for ourselves since the viewpoint is always at
 *  the origin.
 */
class frustrum {

private:
	float fov, near, far;

	// Scaling factor
	float k;

	// Flags to indicate a points position with respect to the
	//  frustrum, from the eyes viewpoint.
	enum {
		LEFT		= 1<<0,
		RIGHT		= 1<<1,
		ABOVE		= 1<<2,
		BELOW		= 1<<3,
		INFRONT		= 1<<4,		// ie. between eye and frustrum
		BEHIND		= 1<<5		// ie. behind frustrum
	};

public:
	frustrum(float fov=M_PI/2, float near=0, float far=1000);

	bool test_point(const point3d& p);
	bool test_patch(const point3d p[4]);

};

#endif	// _FRUSTRUM_H_
