//
// light.cc
//
// Represent a infinite light source
//
// Copyright (C) J. Belson	2000.06.27
//
// $Author: jon $	:	$Date: 2003/05/26 13:58:06 $
//

#ifndef _LIGHT_H_
#define _LIGHT_H_


#include "fcolour.h"
#include "vector3d.h"


/**
 * Represent a light source at infinite distance
 */
class light_source {

private:

public:
	light_source();

	// Colour of light
	fcolour col;

	// Which direction is light shining in?
	vector3d direction;

	// Return colour of light reflected from a
	//  surface of specified colour
	fcolour reflected(fcolour c);

};

#endif	// _LIGHT_H_
