//
// cloud_window.h
//
// Prefs for cloud generation
//
// Copyright (c) J. Belson	1999.04.05
//
// $Author: jon $	:	$Date: 2003/06/06 21:43:57 $
//

#ifndef _BASE_CLOUD_WINDOW_H_
#define _BASE_CLOUD_WINDOW_H_

#include "base_window.h"
#include "bm_view.h"
#include "fcolour.h"
#include "settings.h"


/**
 * Base class for editting cloud settings
 */
class base_cloud_window : public base_window {

private:
	bool	quit_requested;


protected:
	bm_view*	cloud_view;

	enum {
		CLOUD_WIDTH				= 256,
		DEFAULT_CLOUD_COLOUR	= 230,
		MAX_VALUE				= 100
	};

	static const float DEFAULT_PERSISTENCE;
	static const float DEFAULT_PRESENCE;
	static const float DEFAULT_CLOUD_COVER;
	static const float DEFAULT_SCALE;

	int		seed;

	// Cloud state variebles
	fcolour	cloud_colour;
	float	persistence;
	float	presence;
	float	cloud_cover;
	float	scale;

	settings* my_settings;

	virtual void render_thread(void);

	void set_quit_requested(void) { quit_requested = true; };

	// Update model as sliders change
	void changed_colour(const QColor& col);
	void changed_persistence(int val);
	void changed_presence(int val);
	void changed_cover(int val);
	void changed_scale(int val);


public:
	base_cloud_window();
	virtual ~base_cloud_window();

	virtual void load_settings(void);
};

#endif	// _BASE_CLOUD_WINDOW_H_
