//
// Platform independent preview settings window
//
// Copyright (c) J. Belson	2000.11.04
//
// $Author: jon $	:	$Date: 2003/06/07 14:08:01 $
//


#ifndef _BASE_PREVIEW_WINDOW_H_


#include "GLwindow.h"

class hfield;
class settings;

/**
 * Platform independent base class for an OpenGL preview control window
 */
class base_preview_window {

private:
	enum {
		START_WIDTH		= 320,
		START_HEIGHT	= 240,
		DEFAULT_DETAIL	= 7
	};
	//enum { START_WIDTH = 640, START_HEIGHT = 480 };

protected:
	GLwindow*	win;			// Window to render into

	hfield*		land;
	hfield*		sky;

	int 	seed;
	float	fd;
	int		detail;				// How detailed terrain is

	// Window size
	int w_width, w_height;

	// Do we need to recreate the landscape from the heightfield data?
	bool need_recalc;

	// Rendering preferences state variables
	bool smoothing;
	bool normals;
	bool lighting;
	bool texture;
	bool fogging;
	bool shadows;
	bool track_camera;
	bool draw_sky;
	bool draw_land;

	settings* my_settings;

	// Create and render the preview
	void render_thread(void);

public:
	base_preview_window();
	virtual ~base_preview_window();

	// Store current window position
	virtual void save_position(void) = 0;

};

#endif	// _BASE_PREVIEW_WINDOW_H_
