//
// base_render_window.cc
//
// Main window
//
// Copyright (c) J. Belson	1999.01.04
//


#include "base_render_window.h"


#include "settings.h"
#include "render_window.h"
#include "renderer.h"
#include "zbuffer.h"


/**
 * Constructor
 */
base_render_window::base_render_window()
	: w_width(START_WIDTH),
	  w_height(START_HEIGHT)
{
	my_settings = settings::get_instance();

	// Default rendering preferences
	lighting		= true;
	sky				= true;
	ground			= true;
	atmospherics	= true;
	textures		= true;
	reflections		= true;
	trees			= false;
	shadows			= false;

	my_settings->set_bool(LIGHTING, lighting);

	fd			= 0.65;
	camera_x	= 0;
	camera_y	= -10;	// Slightly above ground
	camera_z	= 0.0;
//	off_z		= -(0.7 * TERRAIN_WIDTH);

	rot_a = rot_b = rot_c = 0.0;
	lift_a = lift_b = lift_c = 0.0;

	my_map		= 0;
	seed		= 1;

	redraw_rate	= 3;
}



/**
 * Destructor
 */
base_render_window::~base_render_window()
{
	;
}



/**
 * Generating and render the landscape.
 */
void base_render_window::main_render_thread(void)
{
	;
}


