//
// Colour.h
//

#ifndef _COLOUR_H_
#define _COLOUR_H_

#include <View.h>

#include "slider.h"


struct hsv_color {
	float h;
	float s;
	float v;
};


class Colour : public BView {

private:
	// Pointer to colorspace converting object
	ConvertColour* Convert;

	// Send colour information to parent window
	BMessage* ColMsg;

	Slider* slider[3];

	float font_height;

	col colour;

	BView* square;

	enum {
		SQR_WIDTH	= 26
	};

	// Draw sqaure in current colour
	void DrawSquare(void);

	// Draw slider labels
	void DrawLabels(void);

	// Update the colour gardients for each slider
	void UpdateSliders(void);

	// Send updated RGB values to parent window
	void SendRGB(void);

	virtual void AttachedToWindow(void);

public:
	Colour(
			BRect frame,
			ConvertColour* Conv,
			BMessage* message,
			uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP,
			uint32 flags = B_NAVIGABLE | B_WILL_DRAW | B_FRAME_EVENTS);
	~Colour();

	// Change the colourspace by supplying new converter
	void SetConverter(ConvertColour* Conv);

	// Set widget's current colour
	void SetColour(uint8 red, uint8 green, uint8 blue);

	virtual void Draw(BRect update);
	virtual void MessageReceived(BMessage* msg);

};

#endif	// _COLOUR_H_

