//
// ConvertColour.h
//
// J. Belson	2000.06.08
//


#ifndef _CONVERTCOLOUR_H_
#define _CONVERTCOLOUR_H_

#include <support/SupportDefs.h>

#include "colour_struct.h"


//
// This is an abstract base class which converts from
//  an arbitrary colourspace to RGB and vice versa.
//

class ConvertColour {

public:
	ConvertColour(void) { };

	// Slider designations, eg. RGB
	char letter[3];

	// Default does no colourspace convertion
	virtual col FromRGB(uint8 r, uint8 g, uint8 b) = 0;

	// Default does no colourspace convertion
	virtual void ToRGB(col colour, uint8* r, uint8* g, uint8* b) = 0;

};

#endif	// _CONVERTCOLOUR_H_

