//
// bm_GLwindow.h
//
// Simple window with a bitmap to render into
//
// Copyright (c) J. Belson	1999.1.2
//


#ifndef _BM_GLWINDOW_H_
#define _BM_GLWINDOW_H_

#include "GLview.h"
#include "Window.h"
#include "triangle2d.h"


class GLwindow : public BWindow
{
	private:
		GLview *view;

	public:
		GLwindow(BRect r, char *name, window_type t, ulong mode);
		~GLwindow();
		
		void test_GL(void)	{ view->do_GL(); }

		// Create and render OpenGL model...
		void make_model(const point3d *p, int width);
		void render_model(void);

		// Switch between rendering modes
		void wireframe(void)	{ view->wireframe(); };
		void flat(void)			{ view->flat(); };
		void smooth(void)		{ view->smooth(); };

		void render_triangle(triangle2d *t);
		void plot_point(float x, float y);
		void draw_line(float x, float y, float x2, float y2);

		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage *);
};


#endif	// _GLWINDOW_H_
