//
// bm_view.cc
//
// View that can redraw its contents
//
// Copyright (c) J. Belson	1998.12.12
//

#include <iostream.h>
#include <stdlib.h>
#include <Bitmap.h>
#include <string.h>
#include "bm_view.h"

//
// Constructor/destructor
//
bm_view::bm_view(BRect rect, int bit_depth)
	: BView(rect, "bitmap_view", 0, B_WILL_DRAW | B_PULSE_NEEDED)
{
	cout << "bm_view::bm_view" << endl;

	switch (bit_depth) {
		case 32:
			bm = new BBitmap(rect, B_RGB32);
			break;
//		case 8:
//			bm = new BBitmap(rect, B_CMAP8);
//			break;
		default:
			cerr << "bm_view::bmview() - " << endl;
			cerr << "Unsupported bit depth " << bit_depth << endl;
			cerr << ". Defaulting to 32 bit" << endl;
			bm = new BBitmap(rect, B_RGB32);
			break;
	}

	//bm			= new BBitmap(rect, B_CMAP8 /*B_RGB32*/);
	bm_data		= (uchar *) bm->Bits();
	bytes_per_row	= bm->BytesPerRow();
}

bm_view::~bm_view()
{
	delete bm;
}



//
// Update display on pulse events
//
void bm_view::Pulse(void)
{
	Draw(Bounds());
}



//
// Refresh view from bitmap
//
void bm_view::Draw(BRect rect)
{
//	cout << "bm_view::Draw()" << endl;

	DrawBitmap(bm, rect, rect);

//	DrawBitmap(bm);
}


void bm_view::refresh(BRect rect)
{
	Draw(rect);
}


