//
// bm_view.h
//
// View that can redraw its contents
//
// Copyright (c) J. Belson	1998.12.12
//

#ifndef _BM_VIEW_H_
#define _BM_VIEW_H_

#include "View.h"

// Probably little-endian specific, easy to change though
#define MAKE_COLOUR(r, g, b) ((uchar(r)) << 16 | (uchar(g)) << 8 | (uchar(b)))


class bm_view : public BView {
	private:
		BBitmap*	bm;
		uchar*		bm_data;
		int			bytes_per_row;

		virtual void Pulse(void);

	public:
		bm_view(BRect rect, int bit_depth);
		~bm_view();

		virtual void Draw(BRect rect);

		void* get_bitmap_data()		{ return bm_data;			}
		int get_bytes_per_row()		{ return bytes_per_row;		}
		const BBitmap* get_bitmap()	{ return bm;				}
		void refresh(BRect rect);
};


#endif	// _BM_VIEW_H_
