//
// preview_window.h
//
// Adjustable preview window
//
// Copyright (c) J. Belson	1998.12.14
//


#ifndef _PREVIEW_WINDOW_H_
#define _PREVIEW_WINDOW_H_

#include <time.h>

#include "MTextControl.h"
#include "smart_window.h"

#include "base_preview_window.h"

#include "GLwindow.h"
#include "hf.h"
#include "messages.h"
#include "terrain.h"
#include "types.h"



class preview_window : public smart_window, base_preview_window
{
	private:
		BWindow *parent;

		uchar	palette[4];



		//MTextControl *fd_widget;
		thread_id the_thread;



		void rerender_thread(void);
		static long preview_thread_func(void *obj);
		static long rerender_thread_func(void *obj);

	public:
		preview_window(BWindow *, BRect, char *, window_type, ulong);
		~preview_window();

		static const uint32	MSG_LIGHTING	= 'ID-1';
//		static const uint32	MSG_RERENDER	= 'ID-2';
		static const uint32	MSG_TYPE		= 'ID-3';
		static const uint32	MSG_DETAIL		= 'ID-4';
		static const uint32	MSG_TEXTURE		= 'ID-5';
		static const uint32 MSG_FOGGING		= 'ID-6';
		static const uint32 MSG_SHADOWS		= 'ID-7';
		static const uint32 MSG_SMOOTHING	= 'ID-8';
		static const uint32 MSG_UPDATE		= 'ID-9';
		static const uint32 MSG_NORMALS		= 'ID-a';


		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage*);
};



#endif	// _PREVIEW_WINDOW_H_


