//
// progress.cc
//
// Simple pop-up window that displays a
//  progress message
//
// Copyright (c) J. Belson	1999.05.31
//


#include <Font.h>
#include <Polygon.h>
#include <Screen.h>
#include <Window.h>

#include "progress.h"

#include <iostream.h>

progress::progress(const char *msg) :
	smart_window /*BWindow*/(BRect(0, 100, 0, 100), "Progress",
	B_FLOATING_WINDOW	/*B_TITLED_WINDOW*/, B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_NOT_CLOSABLE)
{
	// Calculate correct height for window...
	font_height height;
	be_plain_font->GetHeight(&height);
	text_height = height.ascent + height.descent;
	ResizeTo(WINDOW_WIDTH, 10 + 3*text_height);

	// Nice grey background
	BView *background = new BView(Bounds(), "Background view", 0, 0);
	AddChild(background);
	background->SetViewColor(219, 219, 219);

	BRect r = Bounds();
	r.InsetBy(4.0, text_height/2);
	status = new BStatusBar(r, "progress_statusbar", msg);
	background->AddChild(status);

	Show();

	percentage = 0.0;
}



void progress::Quit(void)
{
	smart_window::Quit();

	//delete status;
}



//
// Change message above status bar
//
void progress::set_message(const char *message)
{
	if (Lock()) {
		status->Reset(message);
		Unlock();
	}
}


//
//  Increase bar value by argument
//
void progress::update_status(float p)
{
	if (Lock()) {
		status->Update(p);
		Unlock();
	}
}



//
// Set full-range value of status gar
//
void progress::set_maximum(float m)
{
	if (Lock()) {
		status->SetMaxValue(m);
		Unlock();
	}
}


