//
// render_window.h
//
// Redner window
//
// Copyright (c) J. Belson	1999.01.04
//


#ifndef _RENDER_WINDOW_H_
#define _RENDER_WINDOW_H_

#include <Message.h>
#include <time.h>

#include "smart_window.h"
#include "SpinButton.h"
#include "MCheckBox.h"
#include "MPopup.h"
#include "MTextControl.h"

#include "messages.h"


#include "base_render_window.h"



class render_window : public smart_window, public base_render_window
{
	private:
		bm_window	*win;		// Separate indow to render into
		BWindow		*parent;

		enum {
			MAX_NUM_THREADS		= 8,
			DEFAULT_NUM_THREADS	= 2
		};


		MTextControl *fd_widget;

		MCheckBox*	cb_shadows;
		MCheckBox*	cb_textures;
		MCheckBox*	cb_lighting;
		MCheckBox*	cb_reflections;
		MCheckBox*	cb_trees;
		MCheckBox*	cb_atmospherics;
		MCheckBox*	cb_clouds;
		MCheckBox*	cb_smoothing;
		MPopup*		popup_threads;
		MPopup*		popup_size;

		BMessage *msg_texture, *msg_lighting, *msg_shadows;
		BMessage *msg_reflections, *msg_trees, *msg_atmospherics;
		BMessage *msg_clouds, *msg_smoothing, *msg_size;
		BMessage *msg_update, *msg_threads, *msg_render;

		void launch_render_thread(void);

		// Main rendering thread
		thread_id the_thread;
		void main_render_thread();
		static long render_thread_func(void *obj);

		// Strip rendering sub-thread
		thread_id render_thread_id[MAX_NUM_THREADS];
		renderer* render_thread[MAX_NUM_THREADS];
		static long render_strip_thread_func(void *obj);

		// Handle display window, using w_width/w_height
		void open_output_window(void);

	public:
		render_window(BWindow *, BRect, char *, window_type, ulong);
		~render_window();

		// Access raw image buffer
		const uint32* get_buffer(void);

		const BBitmap* get_bitmap(void);

		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage*);
};



#endif	// _RENDER_WINDOW_H_


