//
// smart_window.cc
//
// Window that loads/saves its current position
//
// Copyright (c) J. Belson	1999.06.06
//


#include <iostream.h>

#include "smart_window.h"


extern PreferenceSet gSettings;


smart_window::smart_window(BRect rect, const char *title, window_type t, ulong flags) :
	MWindow(rect, title, t, flags)
{
//	cout << "start_window::smart_window(" << title << ")" << endl;
	window_title = title;

	// Move me to required position...
	BRect area;
	const void * data;
	ssize_t size;
	uint32 type = '    ';
	if (gSettings.GetData(window_title, data, size, type) || (type != B_RECT_TYPE)) {
		// Oops, failed
		cerr << "Prefs load failed for \"" << title << "\"" << endl;
	} else {
		memcpy(&area, data, size);
		MoveTo(area.left, area.top);
	}

}


void smart_window::Quit(void)
{
//	cout << "saving prefs for window \"" << window_title << "\"" << endl;

	BRect frame = Frame();
	if (gSettings.SetData(window_title, &frame, sizeof(frame), B_RECT_TYPE)) {
		cerr << "Cannot set frame" << endl;
	} else if (gSettings.Save()) {
		cerr << "Cannot save main window settings" << endl;
	}

	MWindow::Quit();
}





smart_GLwindow::smart_GLwindow(BRect rect, const char *title, window_type t, ulong flags)
	: BDirectGLWindow(	rect,
						title,
						B_TITLED_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL,
						flags | B_ASYNCHRONOUS_CONTROLS | B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	window_title = title;

	// Move me to required position...
	BRect area;
	const void * data;
	ssize_t size;
	uint32 type = '    ';
	if (gSettings.GetData(window_title, data, size, type) || (type != B_RECT_TYPE)) {
		// Oops, failed
		cerr << "Prefs load failed for \"" << title << "\"" << endl;
	} else {
		memcpy(&area, data, size);
		MoveTo(area.left, area.top);
	}

}


void smart_GLwindow::Quit(void)
{
	//cout << "saving prefs for GL window \"" << window_title << "\"" << endl;

	BRect frame = Frame();
	if (gSettings.SetData(window_title, &frame, sizeof(frame), B_RECT_TYPE)) {
		cerr << "Cannot set frame" << endl;
	} else if (gSettings.Save()) {
		cerr << "Cannot save main window settings" << endl;
	}

	BDirectGLWindow::Quit();
}
