//
// GLwindow.cc
//
// Copyright (C) J. Belson	2000.11.07
//
// $Author: jon $	:	$Date: 2003/05/19 13:55:58 $
//

#include <cstdio>

#include "GLwindow.h"


/**
 * Perform any initialisation (called once before either
 *  resizeGL or paintGL)
 */
void GLwindow::initializeGL(void)
{
	puts("initialiseGL()");

	GLinit();
}


/**
 * Called when the widget has been resized or first created
 */
void GLwindow::resizeGL(int w, int h)
{
	printf("resizeGL(%d, %d)\n", w, h);
}


/**
 * Gets called whenever the widget needs to be repainted
 */
void GLwindow::paintGL(void)
{
	;
}


/**
 * Basic OpenGL setup
 */
void GLwindow::GLinit(void)
{
	base_GLwindow::GLinit();
}


/**
 * Render land and sky as requested
 */
void GLwindow::render(bool draw_land, bool draw_sky)
{
	puts("GLwindow::render()");


// Fix viewport to window size
glViewport(0, 0, size().width(), size().height());


//pp = p; nn = n; ww = width;

	base_GLwindow::render(draw_land, draw_sky);

	// Update by calling glDraw
//	updateGL();
	glDraw();
}



void GLwindow::closeEvent(QCloseEvent* /*e*/)
{
	;
}


/**
 * User is trying to resize the OpenGL window, intervene to maintain
 *  aspect ratio.
 * @todo Write code to allow resizable OpenGL window
 */
void GLwindow::resizeEvent(QResizeEvent *re)
{
	puts("Resizing");

	int width = re->size().width();
	int height = re->size().height();

	// Maintain 4:3 aspect
	if (width/height > 4.0/3.0) {
		width = int (4.0/3.0 * height);
		resize(width, height);
	} else if (width/height < 4.0/3.0) {
		height = int (width*3.0/4.0);
		resize(width, height);
	}
	//if (heightfield) make_model(heightfield);
}


