//
// GLwindow.h
//
// Copyright (C) J. Belson	2000.11.07
//
// $Author: jon $	:	$Date: 2003/05/19 13:55:58 $
//

#ifndef _GL_WINDOW_H_
#define _GL_WINDOW_H_


#include "qgl.h"
#include "base_GLwindow.h"


/**
 * Qt specific OpenGL support code
 */
class GLwindow : public QGLWidget, public base_GLwindow {

	Q_OBJECT

private:
	const point3d*	pp;
	const vector3d*	nn;
	int				ww;

protected:
	virtual void initializeGL(void);
	virtual void resizeGL(int w, int h);
	virtual void paintGL(void);


public:
	GLwindow(int w, int h)
		: QGLWidget(0, "", 0 /*, WStyle_Customize|WStyle_DialogBorder*/),
		  base_GLwindow(w, h) { ; }

	virtual void GLinit();

	virtual void render(bool draw_land=true, bool draw_sky=true);

	virtual void resizeEvent(QResizeEvent *);
	virtual void closeEvent(QCloseEvent *);
};



#endif	// _GLWINDOW_H_

