//
// bm_view.cc
//
// Copyright (C) J. Belson	2000.11.18
//


#include <cstdio>
#include <cmath>
#include <qpainter.h>

#include "vector3d.h"
#include "bm_view.h"


bm_view::bm_view(
					QWidget* parent,
					const char* name,
					int width,
					int height)
	: QWidget(parent, name),
	  WIDTH(width)
{
	image = new QImage(width, height, 32);

	const int bpr			= get_bytes_per_row();
	unsigned long int* p	= (unsigned long int*) get_bitmap_data();

	memset(p, 0, height*bpr);
}



bm_view::~bm_view()
{
	delete image;
}



int bm_view::get_bytes_per_row(void)
{
	return image->bytesPerLine();
}


void* bm_view::get_bitmap_data(void) 
{
	return image->scanLine(0);
}




//
// Update screen
//
void bm_view::paintEvent(QPaintEvent* e)
{
	QPainter p(this);
	//p.drawImage(0, 0, *image);

	QRect r = e->rect();
	p.drawImage(r.x(), r.y(), *image, r.x(), r.y(), r.width(), r.height());

	//QString s = "Relief map here";
	//p.drawText(100, 100, s);
}



