//
// cloud_window.h
//
// Qt widget to control cloud settings
//
// Copyright (c) J. Belson	2000.10.17
//
// $Author: jon $	:	$Date: 2003/06/06 21:43:57 $
//

#ifndef _CLOUD_WINDOW_H_
#define _CLOUD_WINDOW_H_

#include <qvariant.h>
#include <qwidget.h>

#include "base_cloud_window.h"
#include "widget_clouds.h"
#include "bm_view.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QGroupBox;
class QLabel;
class QPushButton;
class QSlider;


/**
 * Qt specific cloud preferences widget
 */
class cloud_window : public widget_clouds, public base_cloud_window
{
	Q_OBJECT

private:

private slots:
	void slot_colour(const QColor& col);
	void slot_persistence(int val);
	void slot_presence(int val);
	void slot_cover(int val);
	void slot_scale(int val);

	void slot_render(void);

signals:
	void window_closing(void);

public:
	cloud_window(QWidget* p);

	virtual void update_widgets(void);

	void closeEvent(QCloseEvent *);

};

#endif	// _CLOUD_WINDOW_H_
