//
// KMainWindow framework
//
// Copyright (C) J. Belson	2003.03.23
//
// $Author: jon $	: $Date: 2003/03/23 21:09:27 $
//


#include <klocale.h>
#include <kmenubar.h>

#include "kmain_window.h"
#include "version.h"


kmain_window::kmain_window()
	: KMainWindow()
{
	setCaption(APPNAME " v" APPVERSION);

	win = new main_window(this);
	setCentralWidget(win);
	win->show();

	make_menu();
}


kmain_window::~kmain_window()
{
	;
}



/**
 * Add items to default menu
 */
void kmain_window::make_menu(void)
{
	// Create menus...
    QPopupMenu* file = new QPopupMenu;
    file->insertItem( "&Save Image...", win, SLOT(slot_save_image()) );
	file->insertSeparator();
    file->insertItem( "&Quit", win, SLOT(slot_exit()) );

    QPopupMenu* windows = new QPopupMenu;
    windows->insertItem( "&Preview Window",	win, SLOT(slot_preview_win()) );
    windows->insertItem( "&Render Window",	win, SLOT(slot_render_win()) );

	QPopupMenu* settings = new QPopupMenu;
    settings->insertItem( "&User Settings...",	win, SLOT(slot_settings_win()) );

	KPopupMenu* help = helpMenu(i18n(APPNAME " " APPVERSION "\n\nCopyright (C) 2001-3 Jonathan Belson <jon@witchspace.com>"));

//	QString about;
//	about.sprintf("%s v%s\n"
//					"Copyright (C) J. Belson (jon@witchspace.com)",
//						APPNAME, APPVERSION);

	// Create menu bar
	menu_bar = menuBar();
	menu_bar->insertItem( "&File", file );
	menu_bar->insertItem( "&Windows", windows );
	menu_bar->insertItem( "&Settings", settings );
	menu_bar->insertSeparator();
	menu_bar->insertItem("&Help", (QPopupMenu*) help);
}



void kmain_window::closeEvent(QCloseEvent *)
{
	win->slot_exit();
}



void kmain_window::open_windows(void)
{
	win->open_windows();
}



void kmain_window::generate_map(void)
{
	win->generate_map();
}



