//
// lighting_window.h
//
// Prefs for light source
//
// Copyright (c) J. Belson	2000.12.11
//
// $Author: jon $	: 	$Date: 2003/05/27 16:35:20 $
//


#ifndef _LIGHTING_WINDOW_H_
#define _LIGHTING_WINDOW_H_


#include <qvariant.h>
#include <qwidget.h>
#include <kcolorbtn.h>

#include "base_lighting_window.h"
#include "light_vector.h"
#include "widget_lighting.h"
#include "vector3d.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QGroupBox;
class QLabel;
class QPushButton;


/**
 * Qt specific lighting settings
 */
class lighting_window : public widget_lighting, public base_lighting_window
{
	Q_OBJECT

private:

private slots:
	void slot_ambient_changed(const QColor& new_colour);
	void slot_directional_changed(const QColor& new_colour);

	void slot_light_moved(void);

public:
	lighting_window(QWidget* parent = 0);

	virtual void update_widgets(void);

	void closeEvent(QCloseEvent *);

signals:
	void window_closing(void);

};


#endif	// _LIGHTING_WINDOW_H_
