//
// preview_window.h
//
// Copyright (C) J. Belson	2000.03.27
//


#ifndef _PREVIEW_WINDOW_H_
#define _PREVIEW_WINDOW_H_

#include <qpopupmenu.h>
#include <qtabbar.h>
#include <qdialog.h>
#include <qmainwindow.h>

#include "bm_window.h"
#include "base_preview_window.h"
#include "widget_preview.h"
#include "GLwindow.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QComboBox;
class QGroupBox;
class QPushButton;


class preview_window : public widget_preview, public base_preview_window
{
	Q_OBJECT

private:

	QWidget* parent;

	enum {
		WIDTH = 320,
		HEIGHT = 240
	};


public:
	preview_window(QWidget* parent);

	void closeEvent(QCloseEvent *);

	// Create new terrain object and render
	void create_and_render(void);

	// Render current terrain object
	void render(void);

	void hideEvent(QHideEvent* he);
	void showEvent(QShowEvent* se);

	// Store current window position
	virtual void save_position(void);

public slots:
	void slot_exit();

	void slot_smoothing();
	void slot_lighting();
	void slot_fogging();
	void slot_texture();
	void slot_shadows();
	void slot_update();
	void slot_draw_sky();
	void slot_draw_land();
	void slot_detail(int val);
	void slot_close();
	void slot_track_camera();


};

#endif	// _PREVIEW_WINDOW_H_

