//
// progress.h
//
// Simple pop-up window that displays a
//  progress message
//
// Copyright (c) J. Belson	2000.10.21
//
// $Author: jon $	:	$Date: 2003/05/19 21:41:42 $
//


#ifndef _PROGRESS_H_
#define _PROGRESS_H_

#include <stdio.h>

#include "widget_progress.h"
#include "main.h"
#include "stopwatch.h"


/**
 * Qt widget to display progress information while rendering
 */
class progress : public widget_progress {

	Q_OBJECT
	
private:
	bool quit_requested;

	stopwatch* timer;

private slots:
	void slot_cancel();

public:
	progress(const char *message);
	~progress();

	float text_height;
	const char *message;

	enum {
		WINDOW_WIDTH	= 300,
		WINDOW_HEIGHT	= 20
	};

	void closeEvent(QCloseEvent *);

	bool cancelled(void);

	void set_message(const char *message);

	void update_status(void);
};


#endif	// _PROGRESS_H_
