//
// settings_window.cc
//
// Display configuration window
//
// Copyright (C) J. Belson	2002.02.07
//
// $Author: jon $	:	$Date: 2003/05/27 16:35:20 $
//

#ifndef _SETTINGS_WINDOW_H_
#define _SETTINGS_WINDOW_H_

#include <kdialogbase.h>

class QCheckBox;
class QPushButton;

class base_window;
class settings;
class water_widget;


/**
 * Qt specific settings dialog
 */
class settings_window : public KDialogBase
{
	Q_OBJECT

private:
    QCheckBox* cb1;
    QCheckBox* cb2;
    QCheckBox* cb3;
	QPushButton* pb1;
	QPushButton* pb2;
	QPushButton* pb3;

	// Pointer to each settings widget
	base_window* panes[8];

	settings* my_settings;

	void addWaterPage(void);
	void addAtmosphericsPage(void);
	void addLightingPage(void);
	void addSkyPage(void);
	void addCloudsPage(void);
	void addTreesPage(void);
	void addTexturesPage(void);
	void addDebugPage(void);

protected slots:
	virtual void slotOk();
	virtual void slotDefault();

public:
	settings_window(QWidget* parent = 0, const char* name = 0,
			bool modal = false);

	// Store current window position
	virtual void save_position(void);

	void closeEvent(QCloseEvent *);

signals:
	void save_settings(void);

};

#endif	// _SETTINGS_WINDOW_H_
