//
// water_window.h
//
// Qt widget to control water settings
//
// Copyright (c) J. Belson	2000.10.17
//
// $Author: jon $	:	$Date: 2003/05/27 16:35:20 $
//

#ifndef _WATER_WINDOW_H_
#define _WATER_WINDOW_H_

#include "base_water_window.h"
#include "widget_water.h"


/**
 * Qt widget to control water settings
 */
class water_window : public widget_water, public base_water_window
{
	Q_OBJECT

private:
	QColor colour;

private slots:
	void slot_colour_changed(const QColor& new_colour);
	void slot_height_changed(int val);
	void slot_scale_changed(int val);
	void slot_reflectivity_changed(int val);
	void slot_level_changed();

signals:
	void window_closing(void);

public:
	water_window(QWidget* parent=0);

	virtual void update_widgets(void);

	void closeEvent(QCloseEvent *);

};

#endif	// _WATER_WINDOW_H_
